package com.tzld.piaoquan.recommend.framework.common.item;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.Map;
import java.util.Objects;


/**
 * @author sunmingze
 * @date 2023-11-27
 * attention 序列中的item信息
 */

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
public class Item {
    /**
     * poi/deal 等item 类型
     */
    private String itemType;
    /**
     * poi/deal 等item 的id
     */
    private Long itemId;
    /**
     * 用户attention序列中，该item 的行为时间
     */
    private Long timeStamp;

    /**
     * 扩展字段，存放不同触发策略特有的 item 信息
     */
    private Map<String, Object> extInfo;

    public Item(String itemType, Long itemId) {
        this.itemType = itemType;
        this.itemId = itemId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof Item)) {
            return false;
        }
        Item dtype = (Item) o;
        return Objects.equals(getItemType(), dtype.getItemType()) &&
                Objects.equals(getItemId(), dtype.getItemId());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getItemType(), getItemId());
    }

}
