package com.tzld.piaoquan.recommend.framework.ranker;


import com.tzld.piaoquan.recommend.framework.common.item.RankerItem;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;
import com.tzld.piaoquan.recommend.framework.retrieve.candidate.Candidate;
import com.tzld.piaoquan.recommend.framework.common.user.User;
import com.tzld.piaoquan.recommend.framework.retrieve.candidate.IndexDescription;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

public abstract class AbstractRanker {
    protected static Logger LOGGER = LoggerFactory.getLogger(AbstractRanker.class);

    public static final String ADJUST_POSITION_STRING = "position";
    public static final String QUEUE_IDENTIFY_STRING = "queue-identify";
    public static final String ADJUST_LIMIT_STRING = "adjust-limit";
    public static final String ADJUST_RATIO_STRING = "adjust-ratio";
    public static final String RERANK_COUNT_CONF_STRING = "rerank-count";
    public static final String WINDOW_SIZE_CONF_STRING = "window-size";
    public static final String SIMILARITY_LIMIT_CONF_STRING = "similar-limit";

    protected RankerConfig rankConfig;

    public AbstractRanker(RankerConfig config) {
        this.rankConfig = config;
    }

    protected void afterRank() {
        // TODO: add decision label
    }

    public void rank(final RecommendRequest requestContext, final User user, final int requestIndex, List<RankerItem> rankerItems) {
        if (!rankConfig.isEnable()) {
            return;
        }
        doRank(requestContext, user, requestIndex, rankerItems);
        afterRank();
    }

    public abstract void doRank(final RecommendRequest requestContext, final User user, final int requestIndex, List<RankerItem> rankerItems);
}
