package com.tzld.piaoquan.recommend.framework.retrieve;


import com.tzld.piaoquan.recommend.framework.retrieve.candidate.Candidate;
import com.tzld.piaoquan.recommend.framework.common.user.User;
import com.tzld.piaoquan.recommend.framework.retrieve.candidate.IndexDescription;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.util.Map;

public abstract class AbstractRetriever {

    
    public abstract int doRetrieve(Map<String, Candidate> candidates,
                                   final RecommendRequest requestData,
                                   final User user,
                                   final String channelName,
                                   final RetrieveConfig config);

    protected void addCandidateKey(Map<String, Candidate> candidateMap, String queue, IndexDescription index) {
        Candidate candidate = IndexDescription.convertToCandidate(queue, index);
        String mapKey = queue + "##" + candidate.getCandidateQueueName();
        candidateMap.put(mapKey, candidate);
    }
}
