package com.tzld.piaoquan.recommend.framework.retrieve;

import com.tzld.piaoquan.recommend.framework.retrieve.candidate.Candidate;
import com.tzld.piaoquan.recommend.framework.common.user.User;
import com.tzld.piaoquan.recommend.framework.retrieve.candidate.IndexDescription;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;

import java.lang.reflect.InvocationTargetException;
import java.util.Map;

public class RetrieveChannel {
    private String name;
    private AbstractRetriever retriever;
    private RetrieveConfig config;

    public RetrieveChannel(String name) {
        this.name = name;
    }

    public void setConfig(RetrieveConfig config) {
        this.config = config;
    }

    public void setRetrieverClass(String retrieverClass) throws ClassNotFoundException, NoSuchMethodException, IllegalAccessException, InvocationTargetException, InstantiationException {
        this.retriever = (AbstractRetriever) Class.forName(retrieverClass).getConstructor().newInstance();
    }

    public String getName() {
        return name;
    }

    public AbstractRetriever getRetriever() {
        return retriever;
    }

    public RetrieveConfig getConfig() {
        return config;
    }

    public int doRetrieve(Map<String, Candidate> candidates, final RecommendRequest requestData, final User user) {
        return getRetriever().doRetrieve(candidates, requestData, user, getName(), config);
    }

}
