package com.tzld.piaoquan.recommend.framework.retrieve;


import com.google.common.collect.Maps;
import com.tzld.piaoquan.recommend.framework.retrieve.candidate.Candidate;
import com.tzld.piaoquan.recommend.framework.common.user.User;
import com.tzld.piaoquan.recommend.framework.retrieve.candidate.IndexDescription;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;

import org.apache.commons.lang.exception.ExceptionUtils;

import java.util.Map;

public class RetrieverPipeline {

    private Map<String, RetrieveChannel> retrieveMap;

    public RetrieverPipeline(Map<String, RetrieveChannel> retrieverMap) {
        this.retrieveMap = retrieverMap;
    }

    public Map<String, Candidate> doRetrieve(final RecommendRequest requestData, final User user, final String layerPath) {
        Map<String, Candidate> candidates = Maps.newHashMap();
        for (Map.Entry<String, RetrieveChannel> retrieverEntry : retrieveMap.entrySet()) {
            try {
                if (retrieverEntry.getValue().getConfig().isEnable(requestData, layerPath)) {
                    Map<String, Candidate> myCandidates = Maps.newHashMap();
                    retrieverEntry.getValue().doRetrieve(myCandidates, requestData, user);

                    RetrievePipelineUtils.normalizeRetrieve(myCandidates, retrieverEntry.getValue().getConfig().getRecallWeight());
                    int myRequestRecallCount = RetrievePipelineUtils.sumTotalRecallCount(myCandidates);
                    candidates.putAll(myCandidates);
                }
            } catch(Exception e) { // FIXME:
                //
            }
        }

        return candidates;
    }

}
