package com.tzld.piaoquan.recommend.framework.userattention;



import com.tzld.piaoquan.recommend.framework.common.user.User;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;



/**
 * @author sunmingze
 * @date 2023/11/27
 */

public abstract class AbstractUserAttentionExtractor {
    protected UserAttentionExtractorConfig extractorConfig;

    public AbstractUserAttentionExtractor(UserAttentionExtractorConfig extractorConfig) {
        this.extractorConfig = extractorConfig;
    }

    public String getExtractorName() {
        String[] arr = this.extractorConfig.getName().split(".");
        return arr.length > 0 ? arr[arr.length - 1] : "UnKnownExtractor";
    }

    public UserAttentionExtractorConfig getExtractorConfig() {
        return extractorConfig;
    }

    public boolean isEnable() {
        return !this.extractorConfig.getDisableSwitch();
    }

    public abstract void extractAttention(final RecommendRequest requestData, final User user);

    public void loadModel() {
    }
}
