package com.tzld.piaoquan.recommend.framework.userattention;
import com.typesafe.config.Config;

public class UserAttentionExtractorConfig {
    private final String name;  // attention extractor name
    private final Integer priority;
    private final Boolean disableSwitch;
    private final String modelPath;
    private final Config paramConfig; // param config

    public UserAttentionExtractorConfig(String name,
                                    Config paramConfig,
                                    Integer priority,
                                    Boolean disableSwitch,
                                    String modelPath) {
        this.name = name;
        this.paramConfig = paramConfig;
        this.priority = priority;
        this.modelPath = modelPath;
        this.disableSwitch = disableSwitch;
    }

    public Boolean getDisableSwitch() {
        return disableSwitch;
    }

    public Integer getPriority() {
        return priority;
    }

    public String getName() {
        return name;
    }

    public Config getParamConfig() {
        return paramConfig;
    }

    @Override
    public String toString() {
        return "AttentionExtractorConfig{" +
                "name='" + name + '\'' +
                ", priority=" + priority +
                ", disableSwitch=" + disableSwitch +
                ", modelPath='" + modelPath + '\'' +
                ", paramConfig=" + paramConfig +
                '}';
    }
}
