package com.tzld.piaoquan.recommend.framework.userattention;



import com.tzld.piaoquan.recommend.framework.common.user.User;
import com.tzld.piaoquan.recommend.framework.common.user.UserAttention;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

public class UserAttentionExtractorPipeline {
    private List<AbstractUserAttentionExtractor> extractorList = new ArrayList<AbstractUserAttentionExtractor>();

    public UserAttentionExtractorPipeline(List<AbstractUserAttentionExtractor> extractorList) {
        this.extractorList = extractorList;
    }

    public void extractAttention(final RecommendRequest requestData, final User user) {
        if (user.getUserAttention() == null) {
            UserAttention userAttention = new UserAttention();
            user.setUserAttention(userAttention);
        }

        long startTime = System.currentTimeMillis();

        for (AbstractUserAttentionExtractor extractor : extractorList) {
            try {
                if (extractor.isEnable()) {
                    long currStartTime = System.currentTimeMillis();
                    extractor.extractAttention(requestData, user);
                    //
                }
            } catch (Exception e) {
                //
            }
        }
    }
}
