package com.tzld.piaoquan.recommend.framework.utils;



import com.typesafe.config.Config;

import java.util.List;
import java.util.Map;

/**
 * @author sunmingze
 * @date 2019/8/30
 */
public class ConfigUtils {

    public static Config mergeConfig(Config baselineConfig, List<Config> expConfigs) {
        if (expConfigs == null || expConfigs.size() == 0) {
            return baselineConfig;
        }
        Config resultConfig = expConfigs.get(0);
        for (Config config : expConfigs) {
            resultConfig = resultConfig.withFallback(config);
        }
        resultConfig = resultConfig.withFallback(baselineConfig);
        return resultConfig;
    }

    public static void addConfig(int expId, Map<Integer, Config> map, List<Config> expConfigList) {
        if (expId != 0 && map.containsKey(expId)) {
            expConfigList.add(map.get(expId));
        }
    }

    public static double loadOrDefault(Config config, String path, double defaultValue) {
        if (config.hasPath(path)) {
            return config.getInt(path);
        }
        return defaultValue;
    }

    public static int loadOrDefault(Config config, String path, int defaultValue) {
        if (config.hasPath(path)) {
            return config.getInt(path);
        }
        return defaultValue;
    }

    public static boolean loadOrDefault(Config config, String path, boolean defaultValue) {
        if (config.hasPath(path)) {
            return config.getBoolean(path);
        }
        return defaultValue;
    }

    public static String loadOrDefault(Config config, String path, String defaultValue) {
        if (config.hasPath(path)) {
            return config.getString(path);
        }
        return defaultValue;
    }

    public static Config loadOrDefault(Config config, String path, Config defaultValue) {
        if (config.hasPath(path)) {
            return config.getConfig(path);
        }
        return defaultValue;
    }
}
