package com.tzld.piaoquan.recommend.framework.utils;


import java.util.ArrayList;
import java.util.List;

public class Constants {

    public static final String PAGE_CITY_ID = "pageCityId";
    public static final String LOC_CITY_ID = "locCityId";

    public static final String LONGITUDE = "longitude";
    public static final String LATITUDE = "latitude";
    public static final String DEAL_ID = "dealId";

    public static final String FIRST_CATE_ID = "firstCateId";
    public static final String SCEOND_CATE_ID = "secondCateId";
    public static final String THIRD_CATE_ID = "thirdCateId";
    public static final String ORDER_ID = "orderId";
    public static final String MONEY = "money";
    public static final String SESSION = "session";

    public static final String TRACE_ID = "traceid";

    public static final String STRATEGY = "strategy";
    public static final String GLOBAL_ID = "globalId";
    public static final String USERID = "userid";
    public static final String UUID = "uuid";
    public static final String TRIGGER_TYPE = "triggerType";
    public static final String TRIGGER_SOURCE = "triggerSource";
    public static final String ABTEST_INFO = "abtestInfo";
    public static final String ABTEST_INFO_JSON = "abtestInfoJson";
    public static final String CONTEXT_INFO = "contextInfo";

    public static final String USER_SESSION_MAP = "userSessionMap";
    public static final String EXTRA = "extra";
    public static final String CHANNEL = "channel";

    public static final String TYPE = "type";
    public static final String SOURCE = "source";
    public static final String ENV = "env";



    /*
     * cat 等打点常量
     */

    /**
     * 从bates获取用户行为历史数据的返回错误打点key
     */
    public static final String BAYES_UHR_ERROR = "BAYES_UHR_ERROR";


    /**
     * candidate indexQueue keys
     * 解析配置文件格式
     */
    public static final String RECALL_WEIGHT = "recall-weight";
    public static final String INDEX_DESC = "index-desc";
    public static final String ITEM_TYPE = "item-type";
    /**
     * templateNAME
     */
    public static final String INDEX_NAME = "index-name";

    /**
     * source
     */
    public static final String QUEUE_NAME = "queue-name";
    public static final String DB = "db";
    public static final String LBS_TYPE = "lbs-type";


    public static final String TEMPLATE_ID = "template-id";
    public static final String ORDERING = "ordering";


    public static final String KEY_TYPE = "key-type";
    public static final String KEY_TYPE_NAME = "key-type-name";
    public static final String KEY = "key";
    public static final String URL = "url";
    public static final String LBS_ID = "lbs-id";


    public static final String queue = "lbs-type";
    public static final String MATERIAL_ID = "material-id";
    public static final String MATCHES = "matches";
    public static String KEY_TYPE_VALUE = "key-type-value";

    /**
     * item type
     */
    public static final String ITEM_TYPE_POI = "poi";
    public static final String ITEM_TYPE_SGPOI = "sg_poi";
    public static final String ITEM_TYPE_MCPOI = "mc_poi";
    public static final String ITEM_TYPE_ATT = "attention";
    public static final String ITEM_TYPE_PRICE = "price";
    public static final String ITEM_TYPE_DEAL = "deal";
    public static final String ITEM_TYPE_SKU = "sku";
    public static final String ITEM_TYPE_WAIMAI_POI = "poi_waimai";

    public static final String WAIMAI_STR = "waimai";
    public static final String POI_STR = "poi";
    public static final String DEAL_STR = "deal";

    /**
     * indexQueue setCandidateKey generation
     * triggerpoi_{type}_{lbs_type}_{lbs_id}_{topic_id}
     */
    public static final String MATERIAL_PREFIX_KEY = "triggerpoi";

    /**
     * construct key
     */
    public static final String PREFIX_KEY_TYPE = "prefix";
    public static final String CANDIDATE_KEY_TYPE = "candidate";


    /**
     * 召回形式
     */
    public static final String DB_LOCAL = "local";
    public static final String DB_REDIS = "redis";
    public static final String DB_KNN = "knn";

    /**
     * 每个 item type 对应不同的 defaul feature.
     */
    public static final String DEFAULT_USER_FEATURE_KEY = "";
    public static final String DEFAULT_ITEM_FEATURE_KEY = "";

    public static final String CHANNEL_NAME = "smartpush";
    public static final String CHANNEL_NAME_TRIGGER = CHANNEL_NAME + "-trigger";
    public static final String CHANNEL_NAME_PIPE = CHANNEL_NAME + "-pipe";
    public static final String CHANNEL_NAME_RANKER = CHANNEL_NAME + "-ranker";
    public static final String CHANNEL_NAME_Before_RANKER = CHANNEL_NAME + "-BeforeRanker";
    public static final String CHANNEL_NAME_After_RANKER = CHANNEL_NAME + "-AfterRanker";
    public static final String CHANNEL_NAME_Before_RANKER_RECALL = CHANNEL_NAME + "-BeforeRanker_Recall";
    public static final String CHANNEL_NAME_After_RANKER_RECALL = CHANNEL_NAME + "-AfterRanker_Recall";

    public static final String CHANNEL_NAME_FILTER = CHANNEL_NAME + "-filter";
    public static final String CHANNEL_NAME_RERANKER = CHANNEL_NAME + "-reranker";
    public static final String CHANNEL_NAME_RETRIEVER = CHANNEL_NAME + "-retriever";
    public static final String CHANNEL_NAME_RECALLER = CHANNEL_NAME + "-recaller";
    public static final String CHANNEL_NAME_HANDLER = CHANNEL_NAME + "-handler";
    public static final String CHANNEL_NAME_HANDLER_BOOLEAN = CHANNEL_NAME_HANDLER + "-boolean";
    public static final String CHANNEL_NAME_CONSTRUCTOR = CHANNEL_NAME + "-constructor";
    public static final String CHANNEL_NAME_RETURN = CHANNEL_NAME + "-return";

    public static final String STAY_CLUSTER_NAME = "nlpml-udm-godeye-lbs";
    public static final String STAY_CATEGORY_NAME = "LbsStayUuidV2";

    /**
     * pipeline constants
     */
    public static final String User = "User";
    public static final String RECOMMEND_REQUEST_DATA = "RecommendRequestData";
    public static final String RANK_RESULT = "RANK_RESULT";
    public static final String RESULT = "RESULT";
    public static final String SERVICE_CODE = "SERVICE_CODE";
    public static final String GO_FAST = "GO_FAST";

    public static final String RANK_ITEMS = "rankerItems";

    public static final Integer RESULT_SUCCESS = 0;
    public static final Integer PARAM_ERROR = 1;
    public static final Integer CANDIDATE_NULL = 2;

    /**
     * U2T
     */
    public static final String CLIENT_TYPE = "clientType";
    public static final String CLIENT_VERSION = "clientVersion";

    /**
     * 来源
     */
    public static final String SOURCE_BATCH = "batch";
    public static final String SOURCE_RT = "rt";



    /**
     * 单策略索引召回截断50
     */
    public static final Integer RECALL_LIMIT_NUMBER = 50;


    /*
     * ItemTemplate.extraMap 的一些key 的取值
     */

    /*
     * Event 打点的一些 name 常量
     */
    public static final String METRIC_SUCCESS = "success";

    /**
     * 未知异常
     */
    public static final String EXCEPTION_ERR = "exception";
    /**
     * 返回码校验错误
     */
    public static final String METRIC_SERVICE_CODE_FAILURE = "serevice-code-failure";
    /**
     * 参数校验错误
     */
    public static final String METRIC_PARAM_CHECK_FAILURE = "param-failure";


    /**
     * 空返回列表
     */
    public static final String METRIC_BLANK_RETRUN = "blank-return";


    /**
     * 空返回元素
     */
    public static final String METRIC_ELEMENT_BLANK_RETRUN = "blank-element-return";


    /**
     * 空行为
     */
    public static final String METRIC_BLANK_ACTION = "blank-action";

    public static final String METRIC_TRUE = "true";
    public static final String METRIC_FALSE = "false";

    /**
     * 经纬度无效
     */
    public static final String LAT_LNG_INVALID = "invalid-lat-lng";


    /**
     * 候选为空
     */
    public static final String CANDIDATE_MAP_EMPTY = "candidateMapEmpty";

    /**
     * metric status key
     */
    public static final String METRIC_STATUS = "status";

    /**
     * 业务来源标识
     */
    public static final String SG_BU_NAME = "shangou";

    /**
     * 是否上传日志到log表
     * */

    public static final boolean UPLOAD_DATA2LOG_FLAG = true;


}
