package com.tzld.piaoquan.recommend.framework.utils;

import com.google.common.collect.Maps;


import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;



public class ParamUtils {
    private static final Logger LOGGER = LoggerFactory.getLogger(ParamUtils.class);

    /**
     *
     * @param requestData
     * @return
     */
    public static Set<String> getExpIdStrSet(RecommendRequest requestData) {
        Set<String> result = new HashSet<>();
        String expIdStr = getFullExp(requestData);
        if (!StringUtils.isEmpty(expIdStr)) {
            String[] expArr = expIdStr.split(":");
            for (String expId : expArr) {
                result.add(expId);
            }
        }
        return result;
    }

    /**
     * 获取实验id集合,包括新实验平台和老实验平台, 返回 integer 集合
     *
     * @param requestData
     * @return
     */
    public static Set<Integer> getExpIdSet(RecommendRequest requestData) {
        Set<Integer> result = new HashSet<Integer>();

        Set<String> expArr = getExpIdStrSet(requestData);
        if (expArr == null || expArr.isEmpty()) {
            return result;
        }

        for (String expId : expArr) {
            try {
                result.add(Integer.valueOf(expId));
            } catch (Exception e) {
                LOGGER.error("Exception parsing eid error {}", e);
            }
        }

        return result;
    }

    /**
     * 修正带":|"的 expid，如 1:2:3:|123,124 -> 1:2:3
     *
     * @param requestData
     * @return
     */
    public static String getFullExp(RecommendRequest requestData) {
        return "";
    }


    /**
     * 老实验平台, 获取某一层的实验id, layer 从1开始算
     *
     * @param requestData
     * @param layer       index from 1
     * @return
     */
    public static int getExpId(RecommendRequest requestData, int layer) {

        // TODO
        // 获取实验ID

        return 0;
    }

    /**
     * 或者老实验平台某一层的实验id
     *
     * @param wholeExpId
     * @param layer      index from 1
     * @return
     */
    public static int getExpId(String wholeExpId, int layer) {
        int expId = 0;
        if (layer < 1) {
            return expId;
        }
        if (StringUtils.isNotBlank(wholeExpId)) {
            String[] items = wholeExpId.split(":");
            if (items.length >= layer) {
                try {
                    expId = Integer.parseInt(items[layer - 1]);
                    // string is a number
                } catch (NumberFormatException e) {
                    LOGGER.error("exp id error: [{}]", wholeExpId);
                }
            }
        }
        return expId;
    }
}
